<?php

namespace App\Policies\Order\Loan;

use App\Models\Order\Loan\LoanOrder;
use App\Models\User;
use App\Repos\Order\OrderRepo;

class LoanOrderPolicy
{
    /**
     * Determine whether the user can view any models.
     */
    public function viewAny(User $user): bool
    {
        if ($user->isOperator() && $user->cannot('viewLoanOrders')) {
            return false;
        }

        return true;
    }

    /**
     * Determine whether the user can view the model.
     */
    public function view(User $user, LoanOrder $loanOrder): bool
    {
        if ($user->isAdmin()) {
            return true;
        }

        if ($user->isOperator() && $user->can('viewLoanOrders')) {
            return $user->branches()->where('branches.id', $loanOrder->branch_id)->exists();
        }

        if ($user->ownsLoanOrder($loanOrder)) {
            return true;
        }

        return false;
    }

    /**
     * Determine whether the user can create models.
     */
    public function create(User $user): bool
    {
        if ($user->isOperator() && $user->cannot('viewLoanOrders')) {
            return false;
        }

        return true;
    }

    /**
     * Determine whether the user can update the model.
     */
    public function update(User $user, LoanOrder $loanOrder): bool
    {
        if ($user->isAdmin()) {
            return true;
        }

        if ($user->isOperator() && $user->can('viewLoanOrders')) {
            return $user->branches()->where('branches.id', $loanOrder->branch_id)->exists();
        }

        if ($user->ownsLoanOrder($loanOrder) && in_array($loanOrder->status, [
            OrderRepo::PENDING,
        ])) {
            return true;
        }

        return false;
    }

    /**
     * Determine whether the user can delete the model.
     */
    public function delete(User $user, LoanOrder $loanOrder): bool
    {
        if ($user->isAdmin()) {
            return true;
        }

        if ($user->isOperator() && $user->can('viewLoanOrders')) {
            return $user->branches()->where('branches.id', $loanOrder->branch_id)->exists();
        }

        if ($user->ownsLoanOrder($loanOrder)) {
            return true;
        }

        return false;
    }

    /**
     * Determine whether the user can restore the model.
     */
    public function restore(User $user, LoanOrder $loanOrder): bool
    {
        if ($user->isAdmin()) {
            return true;
        }

        return false;
    }

    /**
     * Determine whether the user can permanently delete the model.
     */
    public function forceDelete(User $user, LoanOrder $loanOrder): bool
    {
        if ($user->isAdmin()) {
            return true;
        }

        return false;
    }
}
